来源

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum/

描述

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:
给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

题解

  1. class Solution {
  2. public int[] twoSum(int[] nums, int target) {
  3. Map<Integer, Integer> map = new HashMap<>();
  4. for (int i = 0; i < nums.length; i++) {
  5. int diff = target - nums[i];
  6. if (map.containsKey(diff)) {
  7. return new int[]{map.get(diff), i};
  8. }
  9. map.put(nums[i], i);
  10. }
  11. throw new IllegalArgumentException("No two sum solution");
  12. }
  13. }

复杂度分析:

  • 时间复杂度:1. 两数之和(Two Sum) - 图1。我们只遍历了包含有n个元素的列表一次,在表中进行的每次查找只花费1. 两数之和(Two Sum) - 图2的时间。
  • 空间复杂度:1. 两数之和(Two Sum) - 图3,所需的额外空间取决于哈希表中存储的元素数量,该表最多需要存储个元素。